unit radios;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fpjson, jsonparser;

type
  TUrlList = array of string;

var
  radioList: TStringList;

  {Returns the number of url in table for radio index i }
function getUrlList(i: integer; var urls: TUrlList): integer;

  {Returns the index of first station with the given url }
function urlToIndex(const url: string): integer;

  {Reads the JSON file and populates the internal table of
   radio stations data and fills the radioList with
   displayed name of stations. }
procedure loadRadioJson;
{ TODO 1 : Will have to rewrite as a reloadRadioList function so that the data can be updated at run-time }


implementation

var
  radioJson: TJsonData = nil;
  jaRadios: TJsonArray = nil;


function getUrlList(i: integer; var urls: TUrlList): integer;
var
  jaUrls: TJsonArray;
  j: integer;
  url: string;
begin
  setlength(urls, 0);
  result := 0;
  if (i < 0) or (i >= radioList.Count) then
    exit;
  jaUrls := TJsonObject(jaRadios[i]).Arrays['src'];
  for j := 0 to jaUrls.count-1 do begin
    url := trim(jaUrls[j].AsString);
    if copy(lowercase(url), 1, 4) = 'http' then begin
      if result >= length(urls) then
        setlength(urls, length(urls) + 4);
      urls[result] := url;
      inc(result);
    end;
  end;
  setlength(urls, result);
end;

function urlToIndex(const url: string): integer;
var
  jaUrls: TJsonArray;
  i, j: integer;
begin
  if url <> '' then begin
    for i := 0 to jaRadios.count-1 do begin
      jaUrls := TJsonObject(jaRadios[i]).Arrays['src'];
      for j := 0 to jaUrls.count-1 do
        if url = trim(jaUrls[j].asString) then begin
          result := i;
          exit;
        end;
    end;
  end;
  result := -1
end;

procedure loadRadioJson;
var
  stream: TStream;
  sname: string;
  jaNames: TJsonArray;
  i: integer;
begin
  sname := extractfilepath(ParamStr(0)) + 'radio.json';
  stream := TFileStream.create(sname, fmOpenRead);
  try
    radioJson := GetJSON(stream);
    jaRadios := TJsonObject(radioJson).Arrays['radio'];
    radioList := TStringList.create;

    for i := 0 to jaRadios.Count-1 do begin
      jaNames := TJsonObject(jaRadios[i]).Arrays['name'];
			radioList.add(jaNames[0].AsString);
    end;
  finally
    stream.free
  end;
end;

finalization
  radioJson.free;
  radiolist.free;
end.

